<?php

/* session handler */

class pojisteni_session
{
  public function activate_session() {    
    global $link;  
    session_start();
    
    $deactivate_sessions_q = "UPDATE `st_sessions` SET `status` = 'inactive' WHERE `last_active` < DATE_SUB(NOW(), INTERVAL 15 MINUTE)";
    $deactivate_sessions_e = @mysqli_query($link, $deactivate_sessions_q);    
  
    if(isset($_SESSION['user_id']) && isset($_SESSION['ip_address']) && isset($_SESSION['session_id'])) {
      $search_for_session_q = "SELECT * FROM `st_sessions` 
                               WHERE (`user_id` = ".$_SESSION['user_id']." && `ip_address` = '".$_SESSION['ip_address']."' && 
                                      `id` = '".$_SESSION['session_id']."' && `status` = 'active')";
      $search_for_session_e = @mysqli_query($link, $search_for_session_q);
      if(@mysqli_num_rows($search_for_session_e) == 1) {      
        // this session is active, only set the last_active time
        $update_session_data_q = "UPDATE `st_sessions` SET `last_active` = NOW(), `last_url` = '".$this->get_url()."',  
                                  WHERE (`user_id` = ".$_SESSION['user_id']." && `ip_address` = '".$_SESSION['ip_address']."' && 
                                         `id` = '".$_SESSION['session_id']."') LIMIT 1";
        $update_session_data_e = @mysqli_query($link, $update_session_data_q);
        if(!$update_session_data_e) {
          $this->error_message .= "Error: Cannot update session data (MySQL returns: ".@mysqli_error($link).")";
        }
        return;  
      }    
    } 
    
    // set default session data
    $_SESSION['user_id'] = $this->get_user_id();
    $_SESSION['ip_address'] = $_SERVER['REMOTE_ADDR'];
      
    $save_active_session_q = "INSERT INTO `st_sessions` 
                              SET `user_id` = ".$_SESSION['user_id'].", `ip_address` = '".$_SESSION['ip_address']."', 
                                  `started` = NOW(), `last_active` = NOW(), `start_url` = '".$this->get_url()."', 
                                  `last_url` = '".$this->get_url()."', `status` = 'active'";
    $save_active_session_e = @mysqli_query($link, $save_active_session_q);
    $_SESSION['session_id'] = @mysqli_insert_id($link);
    if(!$save_active_session_e) {
      $this->error_message .= "Error: Cannot execute SQL Query (MySQL returns: ".mysqli_error($link).") <br>\r\n";
    }
    return;              
  } // end function activate_session();
  
  private function get_user_id() {
    global $link;
      
    $select_max_id_q = "SELECT user_id FROM `gt_counter`";
    $select_max_id_e = @mysqli_query($link, $select_max_id_q);
    if(!$select_max_id_e) {
      $this->error_message .= "Error: Cannot get user ID (MySQL returns: ".mysqli_error($link).") <br>\r\n";
    }
      
    $select_max_id_r = @mysqli_fetch_array($select_max_id_e);
    $user_id = $select_max_id_r['user_id'] + 1;
    
    $update_user_id_counter_q = "UPDATE `gt_counter` SET `user_id` = `user_id` + 1";
    $update_user_id_counter_e = @mysqli_query($link, $update_user_id_counter_q);
    if(!$update_user_id_counter_e) {
      $this->error_message .= "Error: Cannot increase user_id counter (MySQL returns: ".mysqli_error($link).") <br>\r\n";
    }  
    return $user_id;
  } // end function get_user_id()
  
  /* 
  Simple function to get current page URL using comman PHP variables 
   
  Function inputs:
      $base if set to true will add the basename to the URL
      $www if set to true will add www. to host if not found
      $query if set to true will add the query string to the URL
      $echo if set to true will echo the URL instead of just returning it
  */
  private function get_url($base = true, $www = false, $query = false, $echo = false) {
    $URL = ''; //open return variable
    $URL .= (($_SERVER['HTTPS'] != '') ? "https://" : "http://"); //get protocol
    $URL .= (($www == true && !preg_match("/^www\./", $_SERVER['HTTP_HOST'])) ? 'www.'.$_SERVER['HTTP_HOST'] : $_SERVER['HTTP_HOST']); //get host
    $path = (($_SERVER['REQUEST_URI'] != '') ? $_SERVER['REQUEST_URI'] : $_SERVER['PHP_SELF']); //tell the function what path variable to use
    $URL .= ((pathinfo($path, PATHINFO_DIRNAME) != '/') ? pathinfo($path, PATHINFO_DIRNAME).'/' : pathinfo($path, PATHINFO_DIRNAME)); //set up directory
    $URL .= (($base == true) ? pathinfo($path, PATHINFO_BASENAME) : ""); //add basename
    $URL  = preg_replace("/\?".preg_quote($_SERVER['QUERY_STRING'])."/", "", $URL); //remove query string if found in url
    $URL .= (($query == true && $_SERVER['QUERY_STRING'] != '') ? "?".$_SERVER['QUERY_STRING'] : ""); //add query string

    return $URL;
  } // end of function get_url() 
} // end class pojisteni_session

?>
